﻿Public Class Form1

    Private Sub C1FlexGrid1_KeyDownEdit(sender As Object, e As C1.Win.C1FlexGrid.KeyEditEventArgs) Handles C1FlexGrid1.KeyDownEdit
        'Get the current cell's Editor As a TextBox
        Dim tb As TextBox = DirectCast(Me.C1FlexGrid1.Editor, TextBox)

        If tb.SelectionLength = 0 Then
            'If the Caret is at the end of the Text (right edge) in TextBox 
            If tb.SelectionStart = tb.Text.Length Then
                'then on the press of Right arrow key 
                'the cursor should move to the next column in same row
                If e.KeyData = Keys.Right Then
                    If e.Col < C1FlexGrid1.Cols.Count - 1 Then
                        C1FlexGrid1.Select(e.Row, e.Col + 1)
                    Else
                        'if it is the last column in the grid then end editing
                        C1FlexGrid1.Select(e.Row, e.Col)
                        C1FlexGrid1.FinishEditing()
                    End If
                End If
                'If the Caret is at the start of the Text (left edge) in TextBox 
            ElseIf tb.SelectionStart = 0 Then
                'then on the press of Left arrow key
                'the cursor should move to the previous column in the same row
                If e.KeyData = Keys.Left Then
                    If e.Col > 1 Then
                        C1FlexGrid1.Select(e.Row, e.Col - 1)
                    Else
                        'if it is the first column in the grid then end editing
                        C1FlexGrid1.Select(e.Row, e.Col)
                        C1FlexGrid1.FinishEditing()
                    End If
                End If
            End If
        End If
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        C1FlexGrid1(1, 1) = "FlexGrid"
    End Sub
End Class
